#pragma once

#include "sdl.hpp"
#include "transform2d.hpp"

#include <array>

class Sprite
{
private:
    SDL2::Texture::UP texture_;

    std::array<Vector2D, 4> corners_;
    std::array<Vector2D, 4> corner_uvs_ = {
        Vector2D(0.0f, 0.0f),
        Vector2D(1.0f, 0.0f),
        Vector2D(1.0f, 1.0f),
        Vector2D(0.0f, 1.0f)};

    const std::array<int, 6> vertex_indices_ = {0, 1, 2, 0, 2, 3};

public:
    Transform2D transform;

    Sprite(SDL2::Texture::UP texture);

    void draw(SDL2::Renderer::SP canvas);
    
    inline Vector2D size()
    {
        int w, h;
        SDL_QueryTexture(texture_.get(), nullptr, nullptr, &w, &h);

        return {static_cast<float>(w), static_cast<float>(h)};
    }
};
