#include "window.hpp"

#include <iostream>


Window::Window(std::string name, size_t width, size_t height)
    : sdl_window_(
          SDL_CreateWindow(
              name.c_str(), SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED,
              width, height, SDL_WINDOW_SHOWN))
{
    if (sdl_window_ == nullptr)
    {
        throw std::runtime_error(SDL_GetError());
    }

    window_renderer_ = SDL2::Renderer::SP(
        SDL_CreateRenderer(sdl_window_.get(), -1, SDL_RENDERER_PRESENTVSYNC));

    if (window_renderer_ == nullptr)
    {
        throw std::runtime_error(SDL_GetError());
    }
}

void Window::update()
{
    SDL_UpdateWindowSurface(sdl_window_.get());
}
