#pragma once

#include <SDL2/SDL.h>

#include <string>
#include <memory>
#include <functional>

#include "vector2d.hpp"
#include "sdl.hpp"

class Window
{
private:
    std::string name_;
    SDL2::Window::UP sdl_window_;
    SDL2::Renderer::SP window_renderer_;

public:
    Window();
    Window(std::string name, size_t width, size_t height);
    void update();

    inline SDL2::Renderer::SP get_renderer() const { return window_renderer_; }
    inline Vector2D size() const
    {
        int w, h;
        SDL_GetWindowSize(sdl_window_.get(), &w, &h);
        return {static_cast<float>(w), static_cast<float>(h)};
    }
};