#include "ball.hpp"

Ball::Ball(SDL2::Renderer::SP renderer) : Entity(renderer),
                                          Collidable(std::make_unique<CircleShape>(Vector2D{0, 0}, 64)),
                                          sprite_(SDL2::Texture::load(renderer, "res/ball.svg")),
                                          shape_{static_cast<CircleShape &>(*Collidable::collision_shape_)}

{
    radius = 8;
}

void Ball::render()
{
    sprite_.transform = transform_;
    sprite_.draw(renderer_);

    #ifdef DEBUG_DRAW
    shape_.debug_draw(renderer_);
    aabb_.debug_draw(renderer_);
    #endif
}

void Ball::update(float delta)
{

}

bool Ball::move_and_collide(Collidable const &other, Vector2D const &v)
{
    set_position(position() + v);

    float const epsilon = 0.1f; 
    bool collided = false;
    while (is_colliding_with(other))
    {
        collided = true;
        set_position(position() - v * epsilon);
    }

    return collided;
}