#pragma once

#include "entity.hpp"
#include "sprite.hpp"
#include "collidable.hpp"

class Ball : public Entity, public Collidable
{
private:
    Sprite sprite_;
    float radius;
    CircleShape& shape_;

public:
    float speed;
    Vector2D direction;

    Ball(SDL2::Renderer::SP renderer);
    
    void update(float delta) override;
    void render() override;
    inline virtual void update_transform()
    {
        Entity::update_transform();
        shape_.origin = this->position();
        shape_.radius = this->radius;
        aabb_ = shape_.get_aabb();
    }


    bool move_and_collide(Collidable const &other, Vector2D const &v);
};
