#include "block.hpp"

Block::Block(SDL2::Renderer::SP renderer)
    : Entity(renderer),
      Collidable(PolygonShape::create_regular(6)),
      sprite_(SDL2::Texture::load(renderer, "res/block.svg"))
{
}

void Block::render()
{
    sprite_.draw(renderer_);

#ifdef DEBUG_DRAW
    collision_shape_->debug_draw(renderer_);
    aabb_.debug_draw(renderer_);
#endif
}

void Block::update(float delta)
{
    sprite_.transform = transform_;
    auto &shape = static_cast<PolygonShape &>(*collision_shape_);
    shape.transform = transform_ * Transform2D::scale(64);
    aabb_ = shape.get_aabb();
}
