#pragma once

#include "sdl.hpp"
#include "entity.hpp"
#include "ball.hpp"
#include "window.hpp"
#include "paddle.hpp"

#include <vector>

class Game
{
private:
    SDL2::Renderer::SP renderer_;
    Window const & game_window_;

    std::vector<Ball> balls_;
    std::vector<Entity::SP> blocks_;
    Paddle paddle_;
    Sprite circle_guide_;

public:
    Game(Window const &game_window);
    void start();
    void update();
    void update(float delta);
    void render();
};
