#pragma once

#include "entity.hpp"
#include "collidable.hpp"
#include "sprite.hpp"

class Paddle : public Entity, public Collidable
{
private:
    PolygonShape& shape_;
    Sprite sprite_;

public:
    Vector2D pivot_point_;
    float radius_ = 200 - 8;
    float angle_ = 0.0f;
    float rotation_speed_radians_ = 1.0f;
    float friction_ = 10.0f;

    Paddle(SDL2::Renderer::SP renderer);

    void update(float delta) override;
    void render() override;

    inline virtual void update_transform()
    {
        shape_.transform = Transform2D::translation(position_) * Transform2D::rotation(rotation_radians_) * Transform2D::scale(16 * 8, 16);
        aabb_ = shape_.get_aabb();
        Entity::update_transform();
    }
};