#include "sdl.hpp"
#include "window.hpp"
#include "game.hpp"


int main(int argc, char **argv)
{
    SDL2::Guard sdl_guard;

    Window window{"Breakin", 1280, 720};
    Game game{window};
    
    game.start();
    
    SDL_Event e;

    bool quit = false;

    while (quit == false)
    {
        // SDL_SetRenderDrawColor(window.get_renderer().get(), 16, 15, 10, 255);
        SDL_SetRenderDrawColor(window.get_renderer().get(), 250, 250, 250, 255);
        SDL_RenderClear(window.get_renderer().get());

        while (SDL_PollEvent(&e))
        {
            if (e.type == SDL_QUIT)
                quit = true;
        }

        game.update();
        game.render();

        SDL_RenderPresent(window.get_renderer().get());
    }

    return EXIT_SUCCESS;
}
